package org.bitbucket.bradleysmithllc.etlunit.feature.file;

import org.bitbucket.bradleysmithllc.etlunit.io.file.DataFileSchema;
import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestValueObject;

import java.io.File;
import java.io.IOException;
import java.util.List;

public interface FileRuntimeSupport
{
	File getDataFileForCurrentTest(String name);

	File getDataFile(String package_, String name);
	File getDataFile(String name);

	File getAssertionFileForCurrentTest(String name);
	File getAssertionFileDirForCurrentTest();
	File getAssertionFileDir(String package_);

	File getAssertionFile(String package_, String name);
	File getAssertionFile(String name);

	File getGeneratedDataFileForCurrentTest(String name);

	File getGeneratedFileSchemaFileForCurrentTest(String name);
	File getGeneratedFileSchemaFile(String _package, String name);

	File getGeneratedDataFile(String package_, String name);
	File getGeneratedDataFile(String name);

	File getReferenceFile(String path, String name);

	File getDataFileDirForCurrentTest();

	File getDataFileDir(String package_);
	File getDataFileDir();

	void registerFileProducer(FileProducer producer);
	FileProducer getRegisteredProducer(String name);

	List<String> getReferenceFileSchemaPackages();
	List<String> getReferenceFileSchemasForPackage(String package_);
	List<File> getReferenceFileSchemaFilesForPackage(String package_);

	List<String> getReferenceFileSchemasForPackageForCurrentTest();

	File getReferenceFileSchemaForCurrentTest(
			String name
	);

	File getReferenceFileSchema(
			String package_,
			String name
	);

	File getReferenceFileSchema(
			String name
	);

	DataFileSchema locateReferenceFileSchemaForCurrentTest(
		String name,
		String generifiedName,
		ETLTestValueObject parameters
	);

	DataFileSchema locateReferenceFileSchema(
		String package_,
		String name,
		String generifiedName,
		ETLTestValueObject parameters
	);

	DataFileSchema locateReferenceFileSchema(
			String name,
			String generifiedName,
			ETLTestValueObject parameters
	);

	void persistDataFileSchema(DataFileSchema schema) throws IOException;
	void persistDataFileSchema(String package_, DataFileSchema schema) throws IOException;
	void persistDataFileSchemaForCurrentTest(DataFileSchema schema) throws IOException;

	void persistGeneratedDataFileSchema(DataFileSchema schema) throws IOException;
	void persistGeneratedDataFileSchema(String package_, DataFileSchema schema) throws IOException;
	void persistGeneratedDataFileSchemaForCurrentTest(DataFileSchema schema) throws IOException;
}